version: '3.8'

services:
    traefik:
        image: traefik
        restart: always
        ports:
            - "80:80"
            - "443:443"
            - "8080:8080"
        volumes:
            - "./.dev/traefik:/traefik"
            - "./.dev/traefik/traefik.toml:/traefik.toml"
            - "/var/run/docker.sock:/var/run/docker.sock:ro"

    rabbitmq:
        image: rabbitmq:3-management
        depends_on:
            - s3
        healthcheck:
            test: [ "CMD", "rabbitmqctl", "status" ]
            interval: 30s
            timeout: 10s
            retries: 5
        volumes:
            - .dev/log/rabbitmq:/var/log/rabbitmq
            - .dev/log/rabbitmq-tracing:/var/tmp/rabbitmq-tracing
        labels:
            traefik.enable: true
            traefik.http.services.rabbitmq.loadbalancer.server.port: 15672
            traefik.http.routers.rabbitmq.rule: "Host(`rabbitmq.p4.local`)"
            traefik.http.routers.rabbitmq.tls: true
            traefik.http.routers.rabbitmq.service: "rabbitmq"
            traefik.http.routers.rabbitmq.entrypoints: websecure

    s3:
        image: localstack/localstack
        ports:
            - "4566:4566"
        environment:
            - DOCKER_HOST=unix:///var/run/docker.sock
            - SERVICES=s3
            - AWS_ACCESS_KEY_ID=test
            - AWS_SECRET_ACCESS_KEY=test
            - AWS_DEFAULT_REGION=us-east-1
        volumes:
            - localstack:/var/lib/localstack
            - "/var/run/docker.sock:/var/run/docker.sock"
        healthcheck:
            test: ["CMD", "curl", "-f", "http://localhost:4566/_localstack/health"]
            interval: 30s
            timeout: 10s
            retries: 3
        labels:
            traefik.enable: true
            traefik.http.services.s3.loadbalancer.server.port: 4566
            traefik.http.routers.s3.rule: "Host(`s3.p4.local`)"
            traefik.http.routers.s3.tls: true
            traefik.http.routers.s3.service: "s3"
            traefik.http.routers.s3.entrypoints: websecure

volumes:
    localstack:
